
/* autogenerated from svolume.orc */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifndef _ORC_INTEGER_TYPEDEFS_
#define _ORC_INTEGER_TYPEDEFS_
#if defined(__STDC_VERSION__) && __STDC_VERSION__ >= 199901L
#include <stdint.h>
typedef int8_t orc_int8;
typedef int16_t orc_int16;
typedef int32_t orc_int32;
typedef int64_t orc_int64;
typedef uint8_t orc_uint8;
typedef uint16_t orc_uint16;
typedef uint32_t orc_uint32;
typedef uint64_t orc_uint64;
#define ORC_UINT64_C(x) UINT64_C(x)
#elif defined(_MSC_VER)
typedef signed __int8 orc_int8;
typedef signed __int16 orc_int16;
typedef signed __int32 orc_int32;
typedef signed __int64 orc_int64;
typedef unsigned __int8 orc_uint8;
typedef unsigned __int16 orc_uint16;
typedef unsigned __int32 orc_uint32;
typedef unsigned __int64 orc_uint64;
#define ORC_UINT64_C(x) (x##Ui64)
#define inline __inline
#else
#include <limits.h>
typedef signed char orc_int8;
typedef short orc_int16;
typedef int orc_int32;
typedef unsigned char orc_uint8;
typedef unsigned short orc_uint16;
typedef unsigned int orc_uint32;
#if INT_MAX == LONG_MAX
typedef long long orc_int64;
typedef unsigned long long orc_uint64;
#define ORC_UINT64_C(x) (x##ULL)
#else
typedef long orc_int64;
typedef unsigned long orc_uint64;
#define ORC_UINT64_C(x) (x##UL)
#endif
#endif
typedef union { orc_int16 i; orc_int8 x2[2]; } orc_union16;
typedef union { orc_int32 i; float f; orc_int16 x2[2]; orc_int8 x4[4]; } orc_union32;
typedef union { orc_int64 i; double f; orc_int32 x2[2]; float x2f[2]; orc_int16 x4[4]; } orc_union64;
#endif
#ifndef ORC_RESTRICT
#if defined(__STDC_VERSION__) && __STDC_VERSION__ >= 199901L
#define ORC_RESTRICT restrict
#elif defined(__GNUC__) && __GNUC__ >= 4
#define ORC_RESTRICT __restrict__
#else
#define ORC_RESTRICT
#endif
#endif

#ifndef ORC_INTERNAL
#if defined(__SUNPRO_C) && (__SUNPRO_C >= 0x590)
#define ORC_INTERNAL __attribute__((visibility("hidden")))
#elif defined(__SUNPRO_C) && (__SUNPRO_C >= 0x550)
#define ORC_INTERNAL __hidden
#elif defined (__GNUC__)
#define ORC_INTERNAL __attribute__((visibility("hidden")))
#else
#define ORC_INTERNAL
#endif
#endif


#ifndef DISABLE_ORC
#include <orc/orc.h>
#endif
void pa_volume_s16ne_orc_1ch (orc_int16 * ORC_RESTRICT d1, int p1, int n);
void pa_volume_s16ne_orc_2ch (orc_int16 * ORC_RESTRICT d1, orc_int64 p1, int n);


/* begin Orc C target preamble */
#define ORC_CLAMP(x,a,b) ((x)<(a) ? (a) : ((x)>(b) ? (b) : (x)))
#define ORC_ABS(a) ((a)<0 ? -(a) : (a))
#define ORC_MIN(a,b) ((a)<(b) ? (a) : (b))
#define ORC_MAX(a,b) ((a)>(b) ? (a) : (b))
#define ORC_SB_MAX 127
#define ORC_SB_MIN (-1-ORC_SB_MAX)
#define ORC_UB_MAX 255
#define ORC_UB_MIN 0
#define ORC_SW_MAX 32767
#define ORC_SW_MIN (-1-ORC_SW_MAX)
#define ORC_UW_MAX 65535
#define ORC_UW_MIN 0
#define ORC_SL_MAX 2147483647
#define ORC_SL_MIN (-1-ORC_SL_MAX)
#define ORC_UL_MAX 4294967295U
#define ORC_UL_MIN 0
#define ORC_CLAMP_SB(x) ORC_CLAMP(x,ORC_SB_MIN,ORC_SB_MAX)
#define ORC_CLAMP_UB(x) ORC_CLAMP(x,ORC_UB_MIN,ORC_UB_MAX)
#define ORC_CLAMP_SW(x) ORC_CLAMP(x,ORC_SW_MIN,ORC_SW_MAX)
#define ORC_CLAMP_UW(x) ORC_CLAMP(x,ORC_UW_MIN,ORC_UW_MAX)
#define ORC_CLAMP_SL(x) ORC_CLAMP(x,ORC_SL_MIN,ORC_SL_MAX)
#define ORC_CLAMP_UL(x) ORC_CLAMP(x,ORC_UL_MIN,ORC_UL_MAX)
#define ORC_SWAP_W(x) ((((x)&0xffU)<<8) | (((x)&0xff00U)>>8))
#define ORC_SWAP_L(x) ((((x)&0xffU)<<24) | (((x)&0xff00U)<<8) | (((x)&0xff0000U)>>8) | (((x)&0xff000000U)>>24))
#define ORC_SWAP_Q(x) ((((x)&ORC_UINT64_C(0xff))<<56) | (((x)&ORC_UINT64_C(0xff00))<<40) | (((x)&ORC_UINT64_C(0xff0000))<<24) | (((x)&ORC_UINT64_C(0xff000000))<<8) | (((x)&ORC_UINT64_C(0xff00000000))>>8) | (((x)&ORC_UINT64_C(0xff0000000000))>>24) | (((x)&ORC_UINT64_C(0xff000000000000))>>40) | (((x)&ORC_UINT64_C(0xff00000000000000))>>56))
#define ORC_PTR_OFFSET(ptr,offset) ((void *)(((unsigned char *)(ptr)) + (offset)))
#define ORC_DENORMAL(x) ((x) & ((((x)&0x7f800000) == 0) ? 0xff800000 : 0xffffffff))
#define ORC_ISNAN(x) ((((x)&0x7f800000) == 0x7f800000) && (((x)&0x007fffff) != 0))
#define ORC_DENORMAL_DOUBLE(x) ((x) & ((((x)&ORC_UINT64_C(0x7ff0000000000000)) == 0) ? ORC_UINT64_C(0xfff0000000000000) : ORC_UINT64_C(0xffffffffffffffff)))
#define ORC_ISNAN_DOUBLE(x) ((((x)&ORC_UINT64_C(0x7ff0000000000000)) == ORC_UINT64_C(0x7ff0000000000000)) && (((x)&ORC_UINT64_C(0x000fffffffffffff)) != 0))
#ifndef ORC_RESTRICT
#if defined(__STDC_VERSION__) && __STDC_VERSION__ >= 199901L
#define ORC_RESTRICT restrict
#elif defined(__GNUC__) && __GNUC__ >= 4
#define ORC_RESTRICT __restrict__
#else
#define ORC_RESTRICT
#endif
#endif
/* end Orc C target preamble */



/* pa_volume_s16ne_orc_1ch */
#ifdef DISABLE_ORC
void
pa_volume_s16ne_orc_1ch (orc_int16 * ORC_RESTRICT d1, int p1, int n){
  int i;
  orc_union16 * ORC_RESTRICT ptr0;
  orc_union16 var38;
#if defined(__APPLE__) && __GNUC__ == 4 && __GNUC_MINOR__ == 2 && defined (__i386__) 
  volatile orc_union32 var39;
#else
  orc_union32 var39;
#endif
  orc_union16 var40;
  orc_union16 var41;
  orc_union32 var42;
  orc_union32 var43;
  orc_union32 var44;
  orc_union32 var45;
  orc_union32 var46;
  orc_union32 var47;
  orc_union16 var48;
  orc_union32 var49;
  orc_union32 var50;

  ptr0 = (orc_union16 *)d1;

    /* 0: loadpl */
    var42.i = p1;
    /* 3: loadpw */
    var39.x2[0] = (int)0x00000000; /* 0 or 0f */
    var39.x2[1] = (int)0x00000000; /* 0 or 0f */

  for (i = 0; i < n; i++) {
    /* 1: loadw */
    var38 = ptr0[i];
    /* 2: convuwl */
    var43.i = (orc_uint16)var38.i;
    /* 4: cmpgtsw */
    var44.x2[0] = (var39.x2[0] > var43.x2[0]) ? (~0) : 0;
    var44.x2[1] = (var39.x2[1] > var43.x2[1]) ? (~0) : 0;
    /* 5: andw */
    var45.x2[0] = var44.x2[0] & var42.x2[0];
    var45.x2[1] = var44.x2[1] & var42.x2[1];
    /* 6: mulhuw */
    var46.x2[0] = ((orc_uint32)((orc_uint16)var43.x2[0]) * (orc_uint32)((orc_uint16)var42.x2[0])) >> 16;
    var46.x2[1] = ((orc_uint32)((orc_uint16)var43.x2[1]) * (orc_uint32)((orc_uint16)var42.x2[1])) >> 16;
    /* 7: subl */
    var47.i = ((orc_uint32)var46.i) - ((orc_uint32)var45.i);
    /* 8: convhlw */
    var48.i = ((orc_uint32)var42.i)>>16;
    /* 9: loadw */
    var40 = ptr0[i];
    /* 10: mulswl */
    var49.i = var40.i * var48.i;
    /* 11: addl */
    var50.i = ((orc_uint32)var47.i) + ((orc_uint32)var49.i);
    /* 12: convssslw */
    var41.i = ORC_CLAMP_SW(var50.i);
    /* 13: storew */
    ptr0[i] = var41;
  }

}

#else
static void
_backup_pa_volume_s16ne_orc_1ch (OrcExecutor * ORC_RESTRICT ex)
{
  int i;
  int n = ex->n;
  orc_union16 * ORC_RESTRICT ptr0;
  orc_union16 var38;
#if defined(__APPLE__) && __GNUC__ == 4 && __GNUC_MINOR__ == 2 && defined (__i386__) 
  volatile orc_union32 var39;
#else
  orc_union32 var39;
#endif
  orc_union16 var40;
  orc_union16 var41;
  orc_union32 var42;
  orc_union32 var43;
  orc_union32 var44;
  orc_union32 var45;
  orc_union32 var46;
  orc_union32 var47;
  orc_union16 var48;
  orc_union32 var49;
  orc_union32 var50;

  ptr0 = (orc_union16 *)ex->arrays[0];

    /* 0: loadpl */
    var42.i = ex->params[24];
    /* 3: loadpw */
    var39.x2[0] = (int)0x00000000; /* 0 or 0f */
    var39.x2[1] = (int)0x00000000; /* 0 or 0f */

  for (i = 0; i < n; i++) {
    /* 1: loadw */
    var38 = ptr0[i];
    /* 2: convuwl */
    var43.i = (orc_uint16)var38.i;
    /* 4: cmpgtsw */
    var44.x2[0] = (var39.x2[0] > var43.x2[0]) ? (~0) : 0;
    var44.x2[1] = (var39.x2[1] > var43.x2[1]) ? (~0) : 0;
    /* 5: andw */
    var45.x2[0] = var44.x2[0] & var42.x2[0];
    var45.x2[1] = var44.x2[1] & var42.x2[1];
    /* 6: mulhuw */
    var46.x2[0] = ((orc_uint32)((orc_uint16)var43.x2[0]) * (orc_uint32)((orc_uint16)var42.x2[0])) >> 16;
    var46.x2[1] = ((orc_uint32)((orc_uint16)var43.x2[1]) * (orc_uint32)((orc_uint16)var42.x2[1])) >> 16;
    /* 7: subl */
    var47.i = ((orc_uint32)var46.i) - ((orc_uint32)var45.i);
    /* 8: convhlw */
    var48.i = ((orc_uint32)var42.i)>>16;
    /* 9: loadw */
    var40 = ptr0[i];
    /* 10: mulswl */
    var49.i = var40.i * var48.i;
    /* 11: addl */
    var50.i = ((orc_uint32)var47.i) + ((orc_uint32)var49.i);
    /* 12: convssslw */
    var41.i = ORC_CLAMP_SW(var50.i);
    /* 13: storew */
    ptr0[i] = var41;
  }

}

void
pa_volume_s16ne_orc_1ch (orc_int16 * ORC_RESTRICT d1, int p1, int n)
{
  OrcExecutor _ex, *ex = &_ex;
  static volatile int p_inited = 0;
  static OrcCode *c = 0;
  void (*func) (OrcExecutor *);

  if (!p_inited) {
    orc_once_mutex_lock ();
    if (!p_inited) {
      OrcProgram *p;

#if 1
      static const orc_uint8 bc[] = {
        1, 9, 23, 112, 97, 95, 118, 111, 108, 117, 109, 101, 95, 115, 49, 54, 
        110, 101, 95, 111, 114, 99, 95, 49, 99, 104, 11, 2, 2, 14, 2, 0, 
        0, 0, 0, 16, 4, 20, 4, 20, 2, 20, 4, 20, 4, 20, 4, 20, 
        4, 115, 32, 24, 154, 34, 0, 21, 1, 78, 37, 16, 34, 21, 1, 73, 
        37, 37, 32, 21, 1, 91, 36, 34, 32, 129, 36, 36, 37, 164, 33, 32, 
        176, 35, 0, 33, 103, 36, 36, 35, 165, 0, 36, 2, 0, 
      };
      p = orc_program_new_from_static_bytecode (bc);
      orc_program_set_backup_function (p, _backup_pa_volume_s16ne_orc_1ch);
#else
      p = orc_program_new ();
      orc_program_set_name (p, "pa_volume_s16ne_orc_1ch");
      orc_program_set_backup_function (p, _backup_pa_volume_s16ne_orc_1ch);
      orc_program_add_destination (p, 2, "d1");
      orc_program_add_constant (p, 2, 0x00000000, "c1");
      orc_program_add_parameter (p, 4, "p1");
      orc_program_add_temporary (p, 4, "t1");
      orc_program_add_temporary (p, 2, "t2");
      orc_program_add_temporary (p, 4, "t3");
      orc_program_add_temporary (p, 4, "t4");
      orc_program_add_temporary (p, 4, "t5");
      orc_program_add_temporary (p, 4, "t6");

      orc_program_append_2 (p, "loadpl", 0, ORC_VAR_T1, ORC_VAR_P1, ORC_VAR_D1, ORC_VAR_D1);
      orc_program_append_2 (p, "convuwl", 0, ORC_VAR_T3, ORC_VAR_D1, ORC_VAR_D1, ORC_VAR_D1);
      orc_program_append_2 (p, "cmpgtsw", 1, ORC_VAR_T6, ORC_VAR_C1, ORC_VAR_T3, ORC_VAR_D1);
      orc_program_append_2 (p, "andw", 1, ORC_VAR_T6, ORC_VAR_T6, ORC_VAR_T1, ORC_VAR_D1);
      orc_program_append_2 (p, "mulhuw", 1, ORC_VAR_T5, ORC_VAR_T3, ORC_VAR_T1, ORC_VAR_D1);
      orc_program_append_2 (p, "subl", 0, ORC_VAR_T5, ORC_VAR_T5, ORC_VAR_T6, ORC_VAR_D1);
      orc_program_append_2 (p, "convhlw", 0, ORC_VAR_T2, ORC_VAR_T1, ORC_VAR_D1, ORC_VAR_D1);
      orc_program_append_2 (p, "mulswl", 0, ORC_VAR_T4, ORC_VAR_D1, ORC_VAR_T2, ORC_VAR_D1);
      orc_program_append_2 (p, "addl", 0, ORC_VAR_T5, ORC_VAR_T5, ORC_VAR_T4, ORC_VAR_D1);
      orc_program_append_2 (p, "convssslw", 0, ORC_VAR_D1, ORC_VAR_T5, ORC_VAR_D1, ORC_VAR_D1);
#endif

      orc_program_compile (p);
      c = orc_program_take_code (p);
      orc_program_free (p);
    }
    p_inited = TRUE;
    orc_once_mutex_unlock ();
  }
  ex->arrays[ORC_VAR_A2] = c;
  ex->program = 0;

  ex->n = n;
  ex->arrays[ORC_VAR_D1] = d1;
  ex->params[ORC_VAR_P1] = p1;

  func = c->exec;
  func (ex);
}
#endif


/* pa_volume_s16ne_orc_2ch */
#ifdef DISABLE_ORC
void
pa_volume_s16ne_orc_2ch (orc_int16 * ORC_RESTRICT d1, orc_int64 p1, int n){
  int i;
  orc_union32 * ORC_RESTRICT ptr0;
  orc_union32 var38;
#if defined(__APPLE__) && __GNUC__ == 4 && __GNUC_MINOR__ == 2 && defined (__i386__) 
  volatile orc_union64 var39;
#else
  orc_union64 var39;
#endif
  orc_union32 var40;
  orc_union32 var41;
  orc_union64 var42;
  orc_union64 var43;
  orc_union64 var44;
  orc_union64 var45;
  orc_union64 var46;
  orc_union64 var47;
  orc_union32 var48;
  orc_union64 var49;
  orc_union64 var50;

  ptr0 = (orc_union32 *)d1;

    /* 0: loadpq */
    var42.i = p1;
    /* 3: loadpw */
    var39.x4[0] = (int)0x00000000; /* 0 or 0f */
    var39.x4[1] = (int)0x00000000; /* 0 or 0f */
    var39.x4[2] = (int)0x00000000; /* 0 or 0f */
    var39.x4[3] = (int)0x00000000; /* 0 or 0f */

  for (i = 0; i < n; i++) {
    /* 1: loadl */
    var38 = ptr0[i];
    /* 2: convuwl */
    var43.x2[0] = (orc_uint16)var38.x2[0];
    var43.x2[1] = (orc_uint16)var38.x2[1];
    /* 4: cmpgtsw */
    var44.x4[0] = (var39.x4[0] > var43.x4[0]) ? (~0) : 0;
    var44.x4[1] = (var39.x4[1] > var43.x4[1]) ? (~0) : 0;
    var44.x4[2] = (var39.x4[2] > var43.x4[2]) ? (~0) : 0;
    var44.x4[3] = (var39.x4[3] > var43.x4[3]) ? (~0) : 0;
    /* 5: andw */
    var45.x4[0] = var44.x4[0] & var42.x4[0];
    var45.x4[1] = var44.x4[1] & var42.x4[1];
    var45.x4[2] = var44.x4[2] & var42.x4[2];
    var45.x4[3] = var44.x4[3] & var42.x4[3];
    /* 6: mulhuw */
    var46.x4[0] = ((orc_uint32)((orc_uint16)var43.x4[0]) * (orc_uint32)((orc_uint16)var42.x4[0])) >> 16;
    var46.x4[1] = ((orc_uint32)((orc_uint16)var43.x4[1]) * (orc_uint32)((orc_uint16)var42.x4[1])) >> 16;
    var46.x4[2] = ((orc_uint32)((orc_uint16)var43.x4[2]) * (orc_uint32)((orc_uint16)var42.x4[2])) >> 16;
    var46.x4[3] = ((orc_uint32)((orc_uint16)var43.x4[3]) * (orc_uint32)((orc_uint16)var42.x4[3])) >> 16;
    /* 7: subl */
    var47.x2[0] = ((orc_uint32)var46.x2[0]) - ((orc_uint32)var45.x2[0]);
    var47.x2[1] = ((orc_uint32)var46.x2[1]) - ((orc_uint32)var45.x2[1]);
    /* 8: convhlw */
    var48.x2[0] = ((orc_uint32)var42.x2[0])>>16;
    var48.x2[1] = ((orc_uint32)var42.x2[1])>>16;
    /* 9: loadl */
    var40 = ptr0[i];
    /* 10: mulswl */
    var49.x2[0] = var40.x2[0] * var48.x2[0];
    var49.x2[1] = var40.x2[1] * var48.x2[1];
    /* 11: addl */
    var50.x2[0] = ((orc_uint32)var47.x2[0]) + ((orc_uint32)var49.x2[0]);
    var50.x2[1] = ((orc_uint32)var47.x2[1]) + ((orc_uint32)var49.x2[1]);
    /* 12: convssslw */
    var41.x2[0] = ORC_CLAMP_SW(var50.x2[0]);
    var41.x2[1] = ORC_CLAMP_SW(var50.x2[1]);
    /* 13: storel */
    ptr0[i] = var41;
  }

}

#else
static void
_backup_pa_volume_s16ne_orc_2ch (OrcExecutor * ORC_RESTRICT ex)
{
  int i;
  int n = ex->n;
  orc_union32 * ORC_RESTRICT ptr0;
  orc_union32 var38;
#if defined(__APPLE__) && __GNUC__ == 4 && __GNUC_MINOR__ == 2 && defined (__i386__) 
  volatile orc_union64 var39;
#else
  orc_union64 var39;
#endif
  orc_union32 var40;
  orc_union32 var41;
  orc_union64 var42;
  orc_union64 var43;
  orc_union64 var44;
  orc_union64 var45;
  orc_union64 var46;
  orc_union64 var47;
  orc_union32 var48;
  orc_union64 var49;
  orc_union64 var50;

  ptr0 = (orc_union32 *)ex->arrays[0];

    /* 0: loadpq */
    var42.i = (ex->params[24] & 0xffffffff) | ((orc_uint64)(ex->params[24 + (ORC_VAR_T1 - ORC_VAR_P1)]) << 32);
    /* 3: loadpw */
    var39.x4[0] = (int)0x00000000; /* 0 or 0f */
    var39.x4[1] = (int)0x00000000; /* 0 or 0f */
    var39.x4[2] = (int)0x00000000; /* 0 or 0f */
    var39.x4[3] = (int)0x00000000; /* 0 or 0f */

  for (i = 0; i < n; i++) {
    /* 1: loadl */
    var38 = ptr0[i];
    /* 2: convuwl */
    var43.x2[0] = (orc_uint16)var38.x2[0];
    var43.x2[1] = (orc_uint16)var38.x2[1];
    /* 4: cmpgtsw */
    var44.x4[0] = (var39.x4[0] > var43.x4[0]) ? (~0) : 0;
    var44.x4[1] = (var39.x4[1] > var43.x4[1]) ? (~0) : 0;
    var44.x4[2] = (var39.x4[2] > var43.x4[2]) ? (~0) : 0;
    var44.x4[3] = (var39.x4[3] > var43.x4[3]) ? (~0) : 0;
    /* 5: andw */
    var45.x4[0] = var44.x4[0] & var42.x4[0];
    var45.x4[1] = var44.x4[1] & var42.x4[1];
    var45.x4[2] = var44.x4[2] & var42.x4[2];
    var45.x4[3] = var44.x4[3] & var42.x4[3];
    /* 6: mulhuw */
    var46.x4[0] = ((orc_uint32)((orc_uint16)var43.x4[0]) * (orc_uint32)((orc_uint16)var42.x4[0])) >> 16;
    var46.x4[1] = ((orc_uint32)((orc_uint16)var43.x4[1]) * (orc_uint32)((orc_uint16)var42.x4[1])) >> 16;
    var46.x4[2] = ((orc_uint32)((orc_uint16)var43.x4[2]) * (orc_uint32)((orc_uint16)var42.x4[2])) >> 16;
    var46.x4[3] = ((orc_uint32)((orc_uint16)var43.x4[3]) * (orc_uint32)((orc_uint16)var42.x4[3])) >> 16;
    /* 7: subl */
    var47.x2[0] = ((orc_uint32)var46.x2[0]) - ((orc_uint32)var45.x2[0]);
    var47.x2[1] = ((orc_uint32)var46.x2[1]) - ((orc_uint32)var45.x2[1]);
    /* 8: convhlw */
    var48.x2[0] = ((orc_uint32)var42.x2[0])>>16;
    var48.x2[1] = ((orc_uint32)var42.x2[1])>>16;
    /* 9: loadl */
    var40 = ptr0[i];
    /* 10: mulswl */
    var49.x2[0] = var40.x2[0] * var48.x2[0];
    var49.x2[1] = var40.x2[1] * var48.x2[1];
    /* 11: addl */
    var50.x2[0] = ((orc_uint32)var47.x2[0]) + ((orc_uint32)var49.x2[0]);
    var50.x2[1] = ((orc_uint32)var47.x2[1]) + ((orc_uint32)var49.x2[1]);
    /* 12: convssslw */
    var41.x2[0] = ORC_CLAMP_SW(var50.x2[0]);
    var41.x2[1] = ORC_CLAMP_SW(var50.x2[1]);
    /* 13: storel */
    ptr0[i] = var41;
  }

}

void
pa_volume_s16ne_orc_2ch (orc_int16 * ORC_RESTRICT d1, orc_int64 p1, int n)
{
  OrcExecutor _ex, *ex = &_ex;
  static volatile int p_inited = 0;
  static OrcCode *c = 0;
  void (*func) (OrcExecutor *);

  if (!p_inited) {
    orc_once_mutex_lock ();
    if (!p_inited) {
      OrcProgram *p;

#if 1
      static const orc_uint8 bc[] = {
        1, 9, 23, 112, 97, 95, 118, 111, 108, 117, 109, 101, 95, 115, 49, 54, 
        110, 101, 95, 111, 114, 99, 95, 50, 99, 104, 11, 4, 4, 14, 2, 0, 
        0, 0, 0, 18, 8, 20, 8, 20, 4, 20, 8, 20, 8, 20, 8, 20, 
        8, 134, 32, 24, 21, 1, 154, 34, 0, 21, 2, 78, 37, 16, 34, 21, 
        2, 73, 37, 37, 32, 21, 2, 91, 36, 34, 32, 21, 1, 129, 36, 36, 
        37, 21, 1, 164, 33, 32, 21, 1, 176, 35, 0, 33, 21, 1, 103, 36, 
        36, 35, 21, 1, 165, 0, 36, 2, 0, 
      };
      p = orc_program_new_from_static_bytecode (bc);
      orc_program_set_backup_function (p, _backup_pa_volume_s16ne_orc_2ch);
#else
      p = orc_program_new ();
      orc_program_set_name (p, "pa_volume_s16ne_orc_2ch");
      orc_program_set_backup_function (p, _backup_pa_volume_s16ne_orc_2ch);
      orc_program_add_destination (p, 4, "d1");
      orc_program_add_constant (p, 2, 0x00000000, "c1");
      orc_program_add_parameter_int64 (p, 8, "p1");
      orc_program_add_temporary (p, 8, "t1");
      orc_program_add_temporary (p, 4, "t2");
      orc_program_add_temporary (p, 8, "t3");
      orc_program_add_temporary (p, 8, "t4");
      orc_program_add_temporary (p, 8, "t5");
      orc_program_add_temporary (p, 8, "t6");

      orc_program_append_2 (p, "loadpq", 0, ORC_VAR_T1, ORC_VAR_P1, ORC_VAR_D1, ORC_VAR_D1);
      orc_program_append_2 (p, "convuwl", 1, ORC_VAR_T3, ORC_VAR_D1, ORC_VAR_D1, ORC_VAR_D1);
      orc_program_append_2 (p, "cmpgtsw", 2, ORC_VAR_T6, ORC_VAR_C1, ORC_VAR_T3, ORC_VAR_D1);
      orc_program_append_2 (p, "andw", 2, ORC_VAR_T6, ORC_VAR_T6, ORC_VAR_T1, ORC_VAR_D1);
      orc_program_append_2 (p, "mulhuw", 2, ORC_VAR_T5, ORC_VAR_T3, ORC_VAR_T1, ORC_VAR_D1);
      orc_program_append_2 (p, "subl", 1, ORC_VAR_T5, ORC_VAR_T5, ORC_VAR_T6, ORC_VAR_D1);
      orc_program_append_2 (p, "convhlw", 1, ORC_VAR_T2, ORC_VAR_T1, ORC_VAR_D1, ORC_VAR_D1);
      orc_program_append_2 (p, "mulswl", 1, ORC_VAR_T4, ORC_VAR_D1, ORC_VAR_T2, ORC_VAR_D1);
      orc_program_append_2 (p, "addl", 1, ORC_VAR_T5, ORC_VAR_T5, ORC_VAR_T4, ORC_VAR_D1);
      orc_program_append_2 (p, "convssslw", 1, ORC_VAR_D1, ORC_VAR_T5, ORC_VAR_D1, ORC_VAR_D1);
#endif

      orc_program_compile (p);
      c = orc_program_take_code (p);
      orc_program_free (p);
    }
    p_inited = TRUE;
    orc_once_mutex_unlock ();
  }
  ex->arrays[ORC_VAR_A2] = c;
  ex->program = 0;

  ex->n = n;
  ex->arrays[ORC_VAR_D1] = d1;
  {
    orc_union64 tmp;
    tmp.i = p1;
    ex->params[ORC_VAR_P1] = ((orc_uint64) tmp.i) & 0xffffffff;
    ex->params[ORC_VAR_T1] = ((orc_uint64) tmp.i) >> 32;
  }

  func = c->exec;
  func (ex);
}
#endif


